#ifndef LINT
static char *rcsid="$Id: dehtml.c,v 1.5 2004/01/29 17:36:38 crosser Exp $";
#endif

/*
	$Log: dehtml.c,v $
	Revision 1.5  2004/01/29 17:36:38  crosser
	init message in log, bump version
	
	Revision 1.4  2003/09/14 22:09:39  crosser
	switch to varpool based API
	
	Revision 1.3  2003/09/10 11:44:43  crosser
	cleanup
	
	Revision 1.2  2003/09/10 10:12:52  crosser
	it works but not sure if HTML comments need special processing.
	
	Revision 1.1.1.1  2003/09/10 09:36:43  crosser
	Imported sources
	
*/
                                                                                
/*
	WHAT IS IT:
		modularized contentfilter for Zmailer
	COPYRIGHT:
		(c) 2003 Eugene G. Crosser <crosser@average.org>
	LICENSE:
		The same set as apply to Zmailer code
*/

#include "config.h"

#include <sys/types.h>
#ifdef STDC_HEADERS
# include <stdio.h>
# include <string.h>
#endif

#include <zmscanner.h>

#include "report.h"

#define min(x,y) (((x)<(y))?(x):(y))

static int
dehtml_setup(void **cfgp)
{
	DPRINT(("dehtml_setup starting\n"));
	ERRLOG((LOG_INFO,"dehtml: %s (%s) OK",VERSION,rcsid));
	return 0;
}

static void
dehtml_term(void **cfgp)
{
	DPRINT(("dehtml_term entered\n"));
}

static int
dehtml_scan(char *stage,int depth,slab_t data,varpool_t vp,void *priv)
{
	int rc;
	slab_t edata;
	char *dec_data;
	char *p,*q;
	enum {pass,intag,inquotes} status;

	DPRINT(("dehtml_scan enter\n"));

	dec_data=(char *)malloc(slab_size(data));
	if (dec_data == NULL) {
		ERRLOG((LOG_ERR,"dehtml could not alloc %d bytes",
							slab_size(data)));
		return ZMSCAN_CONTINUE;
	}

	q=dec_data;
	status=pass;
	for (p=data.beg;p<data.end;p++) switch (status) {
	case pass:
		if (*p == '<') status=intag;
		else *q++=*p;
		break;
	case intag:
		if (*p == '"') status=inquotes;
		else if (*p == '>') status=pass;
		break;
	case inquotes:
		if (*p == '"') status=intag;
		break;
	}

	edata.beg=dec_data;
	edata.end=q;
	edata.atr=data.atr;

	DPRINT(("dehtml_scan decoded size=%d\n",slab_size(edata)));
#if 0
	DPRINT(("data: \"%.*s\"\n",min(20,slab_size(edata)),edata.beg));
#endif

	rc=scandata("content_text_plain",depth,edata,vp);
	free(dec_data);
	return rc;
}

ZMS_MODULE("content_text_html","dehtml",dehtml_setup,dehtml_term,dehtml_scan);

